-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
local ModName, Sequences = ...
local GSE = GSE
---- PRINT MISSING GSE
	if GSE == nil then
	print("Addon requires GSE3. You can get it from Curseforge @https://www.curseforge.com/wow/addons/gse-gnome-sequencer-enhanced-advanced-macros")
	return;
	end
local L = GSE.L
local Statics = GSE.Static
local GSEPlugin = LibStub("AceAddon-3.0"):NewAddon(ModName, "AceEvent-3.0")
-----------------------------------------------------------------------------

if GSE.isEmpty(Sequences) then
  local Sequences = {}
end

-----------------------------------------------------------------------------

---- Put the macros here [[MACRO HERE]]
---- We are storing more detail to give more control.
---- To find the ClassID - /gse showspec will tell you what the ClassID and SpecID is for your character

Sequences["EA_VDH_OB"] = {
    ["Macro"] = [[dSKliaqikPOrHuvCkKQQMLuXTOKk7Isk9lQkddQ6yu0YOupJcnnKkxtuyBcQ6BufmoQsohsvwNOO5Huv6EQk4FIugOQkoiszHqLEOQQMivPUiuyJuf5JQQ0ivvQtkiRKc6LIQMjvrDtrQ2Pk(jvHgku0rrQQSuPspvXuj4QQkzRQk6RusvVvu5UIs7f8xbvgmKdR0IPK8yKmzkXLrTzOIplsgTioTk9AQQMTuUnuA3i(nvgUahxvHwUqpNOPl56svBNc8DbLZtO1tjfMVQSFsdMGaCmHbdAH7tV)oCEex4ydcWiSnMusysRtADsRtADsRtADsdgA9vIlcZxe)exyefrRVsCry(DW4tokVocCmAIhpmyqWXfP4)oSbBTwDB3seWfgpVY6RalBXwGXgVTTPPTx49Iotttye84F4qp8249amPVurNeeGJjiaZNB8Uw1yjiatEwSl34vYGaCmHXh1klj)XEMqXkkhXrLSec3UKuzvKIuuKLC9HAJP4srksij6ctr)22RbChfr6Bn4ydJpQvwkkhwNLmLjxCQok6NG2kYXSkkebhos2MIMkE9ZWXim(OwzPOCyDwYCBvwfLoxlwxmiXjVsOGjplIzKLsqaoMW4R2ykUycJvur5iUKnInBol8AjlCSHXh1klj)XEMqXkkhXrLSec3UKuzvKIuuKLC9HAJP4srksij6ctr)22RbChfr6Bn4yegFuRSuuoSolzktU4uDu0pbTvKJzvuicoCKSnfnv86NHdDW4JALLIYH1zjZTvzvu6CTyDXGeN8kHckyOrvxhrccWXeeGJjm6tF5zrmJSuQp9bhBy8rTYsr5ioQKLq42LKkRImshDELb9GJry0N(YZID5gVswF6dMqKIJgSn4ydJGyadtxoG3ck4ydcWXeg9PV8SiMrwk1N(GJnm(OwzPOCehvYsiC7ssLvr2z4f9SXdhJWOp9LNf7YnELS(0hmHifhnyBWHoyeedyy6Yb8wqbhJGaCmHrF6lplIzKLs9Pp4ydJpQvwkkhXrLSec3UKuzvKTPnEVOdogHrF6lpl2LB8kz9PpycrkoAW2GJjEyeedyy6Yb8wqbh6ab4yccWXeg9PV8SiMrwk1N(GJnm(OwzPOCehvYsiC7ssLvrgPJoVcVnCmcJ(0xEwSl34vY6tFWiigWWqJQUocuWXgeGJjm6tF5zrmJSuQp9bhBy8rTYsr5(P2ykU6qCujlHWTljvwfz6b6HpdpahJWOp9LNf7YnELS(0hmcIbmm0OQRJafCmccWXeg9PV8SiMrwk1N(GJnm(Owzj5p2Zekwr5(jOTICSdXrLSec3UKuzvKIuuKLC9bkhwR2srkYgpDzqVW3rr24Tnn6b4yeg9PV8SyxUXRK1N(GrqmGHHgvDDeOGrqmGHXZoxamD5aEl4ydZuCGN6ju11rGbZ41fVLiuqbtiIv93w95gVRvnwccW83H1QTaCHriEj(5YeWfgH4L4NlBaxOGckyMaMkK3WX0ggRNx)06JReeGcM05A9ERfeG5BUf0Ue)WKuvGmtF(S66S22L43h3WrC7HryBmPKWG7x(P9NyW(THeV(DW07WxbltznWuaxAPc91)UyqR7F63)uyuyy4Fddzy5)RjKHjJFmOrJgnAWGbbhxKI)7WgS1A1TDlraxye84F4yIhpE82WqRVsCryWOHJ42dZ)2kLH8goM2WK(s63wisXrdysDDeaxycr5iWaZ3Clagdmvu6Rfwr)yNbESs1W57qEsitRtrEYfvuicoCKSnfnv86Nv0pbTvKJQH08SqMwNI8KlQO05AX6Ibjo5vQgQgkKCLkc7sfDk6kvKf2YLAl2IIkNIWkQOnmw6WYkcZTISJive91OIOpIUEf5N4ctrHL4uKORxrBKP)kkSBL46lfvj8nQikhPUKE2IIK9bbUyPOkHLSIWUurNurH56BwuKvSIW6KLI6jTRFUjATkACkAvKmX1xkY1xkQCkAjwuewrfXfhjBtrvYs8lveVujkAjwueBahfvK8ss1yf5iSIC4OOkHXAnH5SyzyWGw4(07VdNhXfgpVY6RalBXwGXgVTjEJ2gXJ30mdty8MXz7BfCmHzcyQqEdNm8YegRNx)06JReeGcMFhm(KJYRJahJM2Mqbfuaa]],
    ["SpecID"] = 581,
    ["ClassID"] = 12
}
Sequences["EA_HDH_OB"] = {
    ["Macro"] = [[dav1iaakri1Pebywk6wQsXUuiQFPQQHjOoMOAzkLNjkMMsORPkvBteQVPsKXjsCofQwhuI5jcK)PqzGke5GkPfkGhcLAIIuxui2OiQpQsuJuL0jfjTsb6LcYmfrUPs0oHQFcL0qHchveuTurPNczQKYvvLsBvvfFvLWyfHO1kcjVfv4UOI2lXFvimyjhwQflKEmPAYkvxMQnRe8zvjJwvCAkTArq51QuZwf3wvz3a)MKHRGJlcILJYZPy6GUoQ02HI(UQkDEHA9kKMpQA)ipCeKw4iqDHriCGraTKlAcEUGISoIRPVocSgqW3enbP1hhancAS5yZXMJnhBo2CmbTYf(Oyc6TGBG6xavRCHpkMGUmkYpoZyvabptE43fueWckMUJT6BOHDu7XcJLackP2aF7WEd9DbTfEBlppFXWJ)(4VNlOl8(ELlRnIMaf0YwNPmIMGNlAc6NMz7Oh3iAckKhN1pEBCrtWZf0F92aPIdGs)Pba)ybV4KQahUmbkOqEmgm3yenbpxq)Hn7LdDG)ftfha1tZ(4KJDV35uW3e0F92aPIJp1ow6dKtQs3SBGBmcEgb9xVnqQ44tTJfZJDb4CKgoDSZ4KQLoS)uSHhLXAeOaf0Qo0QagrtWZfnbpxqepXhYJXG5gdXt8c(MG(R3givCau6pna4hl4fNuLNsklo(4cEgbr8eFipoRF824epXlOubqNHzFe8nbPfp4ckRp4nuGc(MOj45cI4j(qEmgm3yiEIxW3e0F92aPIdGs)Pba)ybV4KQT3tz8TWcEgbr8eFipoRF824epXlOubqNHzFe8mcslEWfuwFWBOaf8mIMGNlAcEUGiEIpKhJbZngIN4f8nb9xVnqQ4aO0FAaWpwWloPkF8ucNNrWZiiIN4d5Xz9J3gN4jEbPfp4cAvhAvabk4BIMGNliIN4d5XyWCJH4jEbFtq)1BdKkoak9Nga8Jf8ItQYS4IPK4nbpJGiEIpKhN1pEBCIN4fKw8GlOvDOvbeOGNr0e8Cbr8eFipgdMBmepXl4Bc6VEBGuXbqP)0aGFSGxCsvMfxmLeVj4zeeXt8H84S(XBJt8eVG0IhCbTQdTkGafKw8GlOKuQbbL1h8gk4Bccb9HK5c0HwfqqyWSkMfglqbkOubr5ApWFAMTJECJOjiSvFrBOeqqAml42H5sabPXSGBhUjbeOafOGqdUEQPf88nbPHvSf8XdVf(scAPd70nSfnbD1pdhl4wqpq4Gbl))h1Qg5JfC)3ple3CfKwFCa0iOarUxXgGzFniiLlJWiDIHdTRpkgAp33rcAFfgHIee7iRRRRRRRW7ij8q3rWoyWHKdGwxf0Lrr(XzgRci4zY3clOvUWhftqrole3Cfe2N2ysnTGNVjOiGfumDhB13qd7O2JfglbeKgwXwWZdhoC4nbD1pdccZCQw27ovJ027H)muW1K0WYBOkzfJQ0n7g4gdfeDn1K1WYBOkzfJQLoS)uSHhLXAOGuqThRHQVwNPOYAOA33T6n03PcQO6lMQ(x3O(CQWOHmxbmuLGYqbPGx0hOZOkGBHoBsvcnrKGtGCVBZOufOzq9r77jvb5AGwavj5(KQLnZqvWjvzJBavlPk0XTGNMTdNuLW8g8MVMzDQykJXoPsZ(r1fUD3btQc6mwVpPk0JQPsJXvbEnPkjU6nvbu7FoBsv6gt7ovRFrzkJvnP6IE0F7rNufYX0cOkz)CSkWKkSESy6SjvlBMvnPkT1HoJkS7rvGjviDfegpPcPouLKR1wMpPkTcaSovzvMr9ZKQLw9N2puH6JTz(XAMuHrZ9q1fUb6mm9dCsvKZRExXMuTSBg0buHzdO6h)yCWKQLkGvVP6Q)n4NjvbvgF4HQigOVqdMuHRGmvuQs0PBqcys16ZNVt1YjvbvpnGQKSG9ecMwdCsvW(wfLQvWUZmoysLMIzpuDTzwW9KQSnypMQandQatQwpnGQlSNpfx4ZKQFuNBNrvaMd2D9BFsvev8KQLn7MQSQOwGrbMuDv95rz(VtQ(uCz9ovDuw)y)MufWbuDvPFBbVMuTMvlsICsvYmFNzVPkzNPmuDT5(6yNuP)WSgQI2)U7GjvbDM)fpPkrPuahAMufIznq1WJZOkG63Jf8AsvO(qv02W6jvoZQtfZQF7SjvrzXnysvaMTbuL2QF7mJcmPkRkQZGuHHDObtQsRa9zFs1kypMQimR(TrbeuAFHM7bk45ckP2aF7WEd9DbTfElpCE4fZtjCI3Yii8(ZfuK1rCn91rG1accn46PMwWF)sxsqx499kxwBenbkOLnGBFsfaDgMoaAvajGafOafb]],
    ["SpecID"] = 577,
    ["ClassID"] = 12
}

-----------------------------------------------------------------------------

---- Because we know the names earlier we can dynamically figure out the names.
local macroNames = {}
-- For each k ("MACRO NAME") and v (the macro string and classid) do this loop
for k,v in pairs(Sequences) do
---- Add the name to the list of macroNames
    table.insert(macroNames, k)
end

-----------------------------------------------------------------------------

local function loadSequences(event, arg)
  if arg == ModName then
---- Force overwrite of macros ignoring the players merge preference
    for k,v in pairs(Sequences) do
        local localsuccess, uncompressedVersion = GSE.DecodeMessage(v.Macro)
        GSE.ReplaceMacro(v.ClassID, k, uncompressedVersion[2])
    end


---- Tell GSE to reload the new stuff
    GSE.PerformReloadSequences()


---- Print Success Message
    GSE.Print("Hello, " .. UnitName("player") .. " " .. UnitLevel("player") .. "  - Elfyau's awesome Macro Set has been loaded.", ModName)
  end
end


if GSE.RegisterAddon(ModName, GetAddOnMetadata(ModName, "Version"), macroNames) then
  loadSequences("Load", ModName)
end

GSEPlugin:RegisterMessage(Statics.ReloadMessage,  loadSequences)
